function get_browser_name() {
    var nAgt = navigator.userAgent;
    var browserName  = navigator.appName;
    var fullVersion  = '' + parseFloat(navigator.appVersion);
    var majorVersion = parseInt(navigator.appVersion, 10);
    var nameOffset, verOffset, ix;

    var versions = {
        "MSIE":    ["Microsoft Internet Explorer", 5],
        "Opera":   ["Opera", 6],
        "Chrome":  ["Chrome", 7],
        "Safari":  ["Safari", 7],
        "Firefox": ["Firefox", 8]
    }

    for (var key in versions) {
        verOffset = nAgt.indexOf(key);
        if (verOffset != -1) {
            browserName = versions[key][0];
            fullVersion = nAgt.substring(verOffset + versions[key][1]);
            break;
        }
    }

    if (verOffset == -1) {
        //MSIE 11
        //Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; rv:11.0) like Gecko
        if (nAgt.indexOf('Trident') != -1) {
            verOffset   = nAgt.indexOf('rv:');
            browserName = "Microsoft Internet Explorer";
            fullVersion = nAgt.substring(verOffset + 3);
        } else if ((nameOffset = nAgt.lastIndexOf(' ') + 1) < (verOffset = nAgt.lastIndexOf('/'))) {
            browserName = nAgt.substring(nameOffset, verOffset);
            fullVersion = nAgt.substring(verOffset + 1);
            if (browserName.toLowerCase() == browserName.toUpperCase()) {
                browserName = navigator.appName;
            }
        }
    }

    // trim the fullVersion string at semicolon/space if present
    if ((ix = fullVersion.indexOf(";")) != -1) {
        fullVersion = fullVersion.substring(0, ix);
    }
    if ((ix = fullVersion.indexOf(" ")) != -1) {
        fullVersion = fullVersion.substring(0, ix);
    }

    majorVersion = parseInt('' + fullVersion, 10);
    if (isNaN(majorVersion)) {
        fullVersion  = '' + parseFloat(navigator.appVersion);
        majorVersion = parseInt(navigator.appVersion, 10);
    }
    return  browserName + ' ' + majorVersion;
}

function getElement(aID)
{ 
    return (document.getElementById) ? document.getElementById(aID) : document.all[aID];
} 

function isUserAgentIE() {
    var browser = get_browser_name();
    return (browser.indexOf('Internet Explorer') >= 0) ? true : false;
}

function isUserAgentFF()
{
	return ( navigator.userAgent.indexOf("Firefox") != -1 || 
           navigator.userAgent.indexOf("Iceweasel") != -1 ) ? true:false;
}

function createPluginInstance(id, clsid, content_type, width, height, ie_codebase, ff_codebase)
{
	if(getElement(id) != null)
		return;
	
	if(isUserAgentIE())
	{
		if(clsid != ''){
			//alert(ie_codebase);
			document.write('<object id="' + id + '" width="' + width + '" height="' + height +'" border="0" classid="' + clsid + '"></object>');
		}
	}
	else/* if(isUserAgentFF())*/
	{
    if( height < 1 ) height = 1;
    if( width < 1 ) width = 1;
    
    if(content_type != '')
      document.write('<object id="' + id + '" width="' + width + '" height="' + height +'" border="0" type="' + content_type + '"></object>');
	}
/*	else
	{
		 if ($('unsupportedBrowserTopNotice')) return;
		 
		 var elBrowserNotice = new Element('div', {	id: 'unsupportedBrowserTopNotice' })
		 	.update(no_browser_plugin)
		 Element.insert($('trSecondBottomBorder').down('td'), elBrowserNotice)
	}*/
}

// function specific to particular plugin
function pluginsLib_createFileSelection(editboxID, editboxSize, tip, assigneeForm, assigneeID, defValue, iePluginUrl )
{
	var tag = '<table><tr><td><input type="text" id="' + assigneeID + '" name="' + assigneeID + '" size="' + editboxSize + '" class="browsetext property genF" value="' + defValue + '" title="'+tip+'"/></td>';
	tag += "<td><img src=\"/img/esuite/button-browse.gif\""
	tag += " onclick=\"pluginsLib_BrowseFile(\'BrowseBtn\', \'" + assigneeID + "\', \'" + assigneeForm + "\', \'"+ assigneeID + "\')\""
	tag += " alt=\"\" onmouseover=\"putSRC(this,\'/img/esuite/button-browse-over.gif\');\" onmouseout=\"putSRC(this,\'/img/esuite/button-browse.gif\');\" onmousedown=\"putSRC(this,\'/img/esuite/button-browse-press.gif\');\" onmouseupup=\"putSRC(this,\'/img/esuite/button-browse-over.gif\');\" /></td></tr></table>";		

	createPluginInstance('BrowseBtn', 'CLSID:F59F239B-1EAF-41B4-AD38-0B386659D3EC', 'application/x-vnd-drweb-browsebtn', 0, 0, iePluginUrl, '/esuite/administration/installBrowserPlugins.ds');
	document.write(tag);
}

function pluginsLib_BrowseFile(buttonID, textboxID, assigneeForm, assigneeID)
{
	var button = getElement(buttonID);
	var textbox = getElement(textboxID);
	if(button != null && textbox != null)
	{
		try {
			button.Browse();
			if (button.FullPath) textbox.value = button.FullPath;
		} catch(e) {}
	}
}

function inputTag(itype,iname,ivalue){
	document.write('<input type="'+itype+'" name="'+iname+'" value="' + ivalue + '" class="property" id="'+iname+'"/>');
}